using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Collections.Generic;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.Sql;
using System.Data.SqlClient;

public partial class BespokeOptions : System.Web.UI.UserControl
{
    Dictionary<string, List<BespokeOptionInfo>> _bespokeOptionData;

    protected void Page_Load(object sender, EventArgs e)
    {
        //
        // Get our list of bespoke options and organize them by category
        //

        SqlConnection connection = new SqlConnection(@"Data Source=TFSRTM;Initial Catalog=Fabrikam;Integrated Security=True");
        _bespokeOptionData = new Dictionary<string, List<BespokeOptionInfo>>();
        
        try
        {
            connection.Open();

            SqlCommand cmd = new SqlCommand("getBespokeOptions", connection);
            cmd.CommandType = CommandType.StoredProcedure;

            //
            // Demo Hack - hard code our product id
            //
            cmd.Parameters.Add("@productId", SqlDbType.Int).Value = 2;
            SqlDataReader reader = cmd.ExecuteReader();

            while(reader.Read())
            {
                string name = reader["Name"] as string;
                string category = reader["CategoryName"] as string;
                string url = reader["Url"] as string;

                BespokeOptionInfo newInfo = new BespokeOptionInfo(name, url);

                if (_bespokeOptionData.ContainsKey(category))
                {
                    List<BespokeOptionInfo> list = _bespokeOptionData[category];
                    list.Add(newInfo);
                }
                else
                {
                    List<BespokeOptionInfo> list = new List<BespokeOptionInfo>();
                    list.Add(newInfo);
                    _bespokeOptionData.Add(category, list);
                }
            }

            BespokeOptionsList.DataSource = _bespokeOptionData;            
            BespokeOptionsList.DataBind();
        }
        finally
        {
            connection.Close();
        }
    }
}